<template lang="pug">
.home__banner
  .home__banner--background
    img(
      v-if="$mq === 'sm'"
      ref="banner_img_sm"
      src="/images/home/TWE-Gerards-Bistro-375-500-c-center.jpg").w-100
    img(
      v-else-if="$mq === 'md'"
      ref="banner_img_md"
      src="/images/home/TWE-Gerards-Bistro-764-600-c-center.jpg").w-100
    img(
      v-else
      ref="banner_img_lg"
      src="/images/home/TWE-Gerards-Bistro-1100x550-c-center.png").w-100

  .home__banner--item.p1 ค้นหาร้านอาหาร ใกล้ตัวคุณ
  .home__banner--item.p3
    .row
      .col-12
        b-form
          b-form-group#input-group-1(
            label=''
            label-for='suggestion'
            description="lorem Consectetur ullamco irure cupidatat ex amet consectetur magna laborum eu minim aute."
            )
            b-input-group
              gmap-autocomplete#suggestion.form-control(ref="suggestion" @place_changed="placeChanged", placeholder="ค้นหาสถานที่ใน Google Map")
              //- b-form-input#input-1(
                v-model='form.keyword'
                type='text'
                required=''
                placeholder='Search Restaurant'
                )
              b-button(
                size="sm"
                @click="updatePlace"
              ) Search

  .home__banner--item.p4 
  .home__banner--item.p5.
    Occaecat esse labore culpa sint fugiat dolore eu duis exercitation in.
    <br>
    Sunt sit nostrud velit pariatur est minim ipsum proident ad sunt cupidatat.

</template>

<script>
import anime from 'animejs'

export default {
  data() {
    return {
      form: {
        keyword: ''
      }
    }
  },

  methods: {
    onAir() {
      this.showBG()
      this.showText()
    },

    showBG() {
      anime({
        targets: '.home__banner--background img',
        scale: [1.3, 1],
        rotate: [-2, 0],
        opacity: [0, 1],
        duration: 1200,
        easing: 'easeOutExpo',
      })
    },

    showText() {
      anime({
        easing: 'easeOutExpo',
        targets: '.p1',
        paddingTop: ['20px', '0'],
        opacity: [0, 1],
        delay: 1000,
        duration: 1000,
      })
      anime({
        easing: 'easeOutExpo',
        targets: '.p3',
        height: [0, '120px'],
        delay: 1400,
        duration: 1000,
      })
      anime({
        easing: 'easeOutExpo',
        targets: '.p4',
        paddingTop: ['20px', '0'],
        opacity: [0, 1],
        delay: 1800,
        duration: 1000,
      })
      anime({
        easing: 'easeOutExpo',
        targets: '.p5',
        paddingTop: ['20px', '0'],
        opacity: [0, 1],
        delay: 2000,
        duration: 1000,
      })
    },

    placeChanged(e){
      localStorage.setItem('findPlace', JSON.stringify({
          name: e.name,
          formatted_address: e.formatted_address,
          location: {
            lat: e.geometry.location.lat(),
            lng: e.geometry.location.lng()
          }
        })
      )
    },
    updatePlace() {
      if(!localStorage.getItem('findPlace') && this.$refs.suggestion.$el.value !== '') {
        localStorage.setItem('findPlace', JSON.stringify({
            name: this.$refs.suggestion.$el.value,
            formatted_address: this.$refs.suggestion.$el.value,
            location: {
              lat: 13.00,
              lng: 100.00
            }
          })
        )
      } 
      this.$router.push({ name: 'explore' })
    }
    
  },
}
</script>

<style lang="scss" scoped>
.home {
  overflow: hidden;
  &__banner {
    position: relative;
    // background-color: $aqua-marine;
    // max-height: 100vh;
    // overflow: hidden;

    &--background {
      overflow: hidden;
      max-height: 500px;
        @media (max-width: $breakpoints-md) {
          max-height: 600px;
        }
        @media (max-width: $breakpoints-sm) {
          max-height: 800px;
        }
      img {
        opacity: 0;
      }
    }

    &--item {
      position: absolute;

      &.p1 {
        color: $primary;
        font-size: 1.5rem;
        top: 17%;
        left: 0;
        right: 0;
        text-align: center;

        @media (max-width: $breakpoints-md) {
          font-size: 1rem;
        }
      }

     
      &.p2 {
        top: 23%;
        left: 50%;
        transform: translateX(-50%);
        max-width: 80%;
      }

      &.p3 {
        top: 32%;
        left: 50%;
        transform: translateX(-50%);
        overflow: hidden;
        .form-group {
          padding: 1.25rem;
          border-radius: 10px;
          background: rgba(255,255,255, 0.25);
          width: 60vw;
          @media (max-width: $breakpoints-md) {
            width: 80vw;
          }
          @media (max-width: $breakpoints-md) {
            width: 90vw;
          }
        }
      }

      &.p4 {
        color: white;
        font-size: 4rem;
        font-weight: 700;
        top: 47%;
        left: 0;
        right: 0;
        text-align: center;

        @media (max-width: $breakpoints-md) {
          font-size: 3.5rem;
        }

        @media (max-width: $breakpoints-sm) {
          font-size: 2rem;
        }
      }

      &.p5 {
        text-align: center;
        color: $secondary;
        font-size: 1.125rem;
        top: 63%;
        left: 0;
        right: 0;
        text-align: center;


        @media (max-width: $breakpoints-md) {
          font-size: 1rem;
        }
      }
    }
  }
}
</style>
